/*
 * Algebraic.h
 *
 *  Created on: 4. 3. 2014
 *      Author: Tomas Pecka
 */

#ifndef RG2RE_ALGEBRAIC_H_
#define RG2RE_ALGEBRAIC_H_

#include <grammar/Grammar.h>
#include <grammar/Regular/RightRG.h>
#include <grammar/Regular/LeftRG.h>

#include <regexp/RegExp.h>

namespace conversions
{

namespace rg2re
{

class Algebraic : public grammar::VisitableConstRGBase
{
public:
    /**
     * @return regexp equivalent to source right regular grammar.
     * @param grammar Grammar to convert
     */
    static regexp::RegExp convert(const grammar::Grammar& grammar);

    static regexp::RegExp convert(const grammar::RightRG& grammar);
    static regexp::RegExp convert(const grammar::LeftRG& grammar);

protected:
    void Visit(void*, const grammar::RightRG& grammar) const;
    void Visit(void*, const grammar::LeftRG& grammar) const;
    void Visit(void*, const grammar::RightLG& grammar) const;
    void Visit(void*, const grammar::LeftLG& grammar) const;

    static const Algebraic RG_TO_RE_ALGEBRAIC;
};

} /* namespace rg2re */

} /* namespace conversions */

#endif /* RG2RE_ALGEBRAIC_H_ */
