#ifndef HDPDA_DETERMINIZER_H_
#define HDPDA_DETERMINIZER_H_

#include "automaton/PDA/RealTimeHeightDeterministicNPDA.h"
#include "automaton/PDA/RealTimeHeightDeterministicDPDA.h"

namespace determinize {

/**
 * Class for running basic determinization algorithm on vpa.
 */
class HDPDADeterminizer {
public:
	/**
	 * Runs determinization algorithm on nondeterministic vpa given in constructor.
	 *
	 * @return deterministic visibly pushdown automaton
	 */
	static automaton::RealTimeHeightDeterministicDPDA determinize(const automaton::RealTimeHeightDeterministicNPDA& nondeterministic);

};

} /* namespace determinize */

#endif /* HDPDA_DETERMINIZER_h_ */
