/*
 * GlushkovPair.cpp
 *
 *  Created on: 14. 4. 2014
 *      Author: Tomas Pecka
 */

#include "GlushkovPair.h"

namespace regexp
{

GlushkovPair::GlushkovPair( GlushkovSymbol const& first, GlushkovSymbol const& second ) :
        m_first( first ), m_second( second )
{

}

bool GlushkovPair::operator<( GlushkovPair const& x ) const
{
    if( m_first.getId( ) == x.m_first.getId( ) )
        return m_second.getId( ) < x.m_second.getId( );
    else
        return m_first.getId( ) < x.m_first.getId( );
}

GlushkovSymbol const& GlushkovPair::getFirst( void ) const
{
    return m_first;
}
GlushkovSymbol const& GlushkovPair::getSecond( void ) const
{
    return m_second;
}

} /* namespace conversions */
