/*
 * RegExpAlternate.h
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_ALTERNATE_H_
#define REG_EXP_ALTERNATE_H_

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExpElements.h>
#include <regexp/unbounded/UnboundedRegExpElements.h>

namespace regexp
{

/**
 * Alternates two regexpses
 *
 */
class RegExpAlternate : public regexp::VisitableRegExpBase::const_promoting_visitor_type
{
public:
	static regexp::RegExp alternate(const regexp::RegExp& first, const regexp::RegExp& second);

	static regexp::FormalRegExp alternate(const regexp::FormalRegExp& first, const regexp::FormalRegExp& second);
	static regexp::UnboundedRegExp alternate(const regexp::UnboundedRegExp& first, const regexp::UnboundedRegExp& second);

private:
	void Visit(void* data, const regexp::UnboundedRegExp& first, const regexp::UnboundedRegExp& second) const;
	void Visit(void* data, const regexp::FormalRegExp& first, const regexp::FormalRegExp& second) const;

	static const RegExpAlternate REG_EXP_ALTERNATE;
};

} /* namespace regexp */

#endif /* REG_EXP_ALTERNATE_H_ */
