/*
 * RegExpConcatenate.h
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_CONCATENATE_H_
#define REG_EXP_CONCATENATE_H_

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExpElements.h>
#include <regexp/unbounded/UnboundedRegExpElements.h>

namespace regexp
{

/**
 * Concatenates two regexpses
 *
 */
class RegExpConcatenate : public regexp::VisitableRegExpBase::const_promoting_visitor_type
{
public:
	static regexp::RegExp concatenate(const regexp::RegExp& first, const regexp::RegExp& second);

	static regexp::FormalRegExp concatenate(const regexp::FormalRegExp& first, const regexp::FormalRegExp& second);
	static regexp::UnboundedRegExp concatenate(const regexp::UnboundedRegExp& first, const regexp::UnboundedRegExp& second);

private:
	void Visit(void* data, const regexp::UnboundedRegExp& first, const regexp::UnboundedRegExp& second) const;
	void Visit(void* data, const regexp::FormalRegExp& first, const regexp::FormalRegExp& second) const;

	static const RegExpConcatenate REG_EXP_CONCATENATE;
};

} /* namespace regexp */

#endif /* REG_EXP_CONCATENATE_H_ */
