/*
 * RegExpIterate.cpp
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#include "RegExpIterate.h"

namespace regexp
{

regexp::RegExp RegExpIterate::iterate(const regexp::RegExp& regexp)
{
	RegExpBase* out;
	regexp.getData().Accept((void*) &out, RegExpIterate::REG_EXP_ITERATE);
	regexp::RegExp res(*out);
	delete out;
	return res;
}

regexp::FormalRegExp RegExpIterate::iterate(const regexp::FormalRegExp& regexp)
{
	return regexp::FormalRegExp(regexp::FormalRegExpIteration(regexp.getRegExp()));
}

regexp::UnboundedRegExp RegExpIterate::iterate(const regexp::UnboundedRegExp& regexp)
{
	return regexp::UnboundedRegExp(regexp::UnboundedRegExpIteration(regexp.getRegExp()));
}

void RegExpIterate::Visit(void* data, const regexp::FormalRegExp& regexp) const
{
	RegExpBase* &ret = *(RegExpBase**) data;
	ret = std::move(RegExpIterate::iterate(regexp)).plunder();
}

void RegExpIterate::Visit(void* data, const regexp::UnboundedRegExp& regexp) const
{
	RegExpBase* &ret = *(RegExpBase**) data;
	ret = std::move(RegExpIterate::iterate(regexp)).plunder();
}

const RegExpIterate RegExpIterate::REG_EXP_ITERATE;

} /* namespace regexp */
