/*
 * RegExpIterate.h
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#ifndef REG_EXP_ITERATE_H_
#define REG_EXP_ITERATE_H_

#include <regexp/RegExp.h>
#include <regexp/formal/FormalRegExpElements.h>
#include <regexp/unbounded/UnboundedRegExpElements.h>

namespace regexp
{

/**
 * Iterates two regexpses
 *
 */
class RegExpIterate : public regexp::VisitableRegExpBase::const_visitor_type
{
public:
	static regexp::RegExp iterate(const regexp::RegExp& regexp);

	static regexp::FormalRegExp iterate(const regexp::FormalRegExp& regexp);
	static regexp::UnboundedRegExp iterate(const regexp::UnboundedRegExp& regexp);

private:
	void Visit(void* data, const regexp::UnboundedRegExp& regexp) const;
	void Visit(void* data, const regexp::FormalRegExp& regexp) const;

	static const RegExpIterate REG_EXP_ITERATE;
};

} /* namespace regexp */

#endif /* REG_EXP_ITERATE_H_ */
