#include "RegExpEmptyTest.h"

#include "regexp/RegExpEmpty.h"

#include <sstream>
#include <regexp/RegExp.h>
#include <regexp/RegExpFromStringParser.h>

CPPUNIT_TEST_SUITE_REGISTRATION( RegExpEmptyTest );

void RegExpEmptyTest::setUp() {
}

void RegExpEmptyTest::tearDown() {
}

void RegExpEmptyTest::testRegExpEmpty() {
	{
		std::string input = "(#E #0 ) + ( #0 a + (b ( #0 (a*) ) ) )";
		std::stringstream inputs(input);
		regexp::RegExpFromStringParser parser(inputs);
		regexp::RegExp re = parser.parseValue();

		CPPUNIT_ASSERT(regexp::RegExpEmpty::languageIsEmpty(re));
	}
	{
		std::string input = "(#E + a ) + ( #0 a + (b ( #0 (a*) ) ) )";
		std::stringstream inputs(input);
		regexp::RegExpFromStringParser parser(inputs);
		regexp::RegExp re = parser.parseValue();

		CPPUNIT_ASSERT(! regexp::RegExpEmpty::languageIsEmpty(re));
	}
}
