/*
 * SymbolFromXMLParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_FROM_XML_PARSER_H_
#define SYMBOL_FROM_XML_PARSER_H_

#include "../sax/FromXMLParserHelper.h"
#include <vector>
#include <set>
#include "Symbol.h"
#include "SymbolFeatures.h"
#include "../sax/Token.h"
#include "../label/Label.h"

#include "BlankSymbol.h"
#include "BottomOfTheStackSymbol.h"
#include "EndSymbol.h"
#include "LabeledSymbol.h"

namespace alib {

template<typename T>
struct api;

} /* namespace alib */

namespace alphabet {

/**
 * Parser used to get String from XML parsed into list of tokens.
 */
class SymbolFromXMLParser : public sax::FromXMLParserHelper {
	Symbol parseSymbol(std::list<sax::Token>& input) const;
	Symbol parseSymbol(std::list<sax::Token>& input, const std::set<FEATURES>& features) const;

	LabeledSymbol parseLabeledSymbol(std::list<sax::Token>& input) const;
	BlankSymbol parseBlankSymbol(std::list<sax::Token>& input) const;
	BottomOfTheStackSymbol parseBottomOfTheStackSymbol(std::list<sax::Token>& input) const;
	EndSymbol parseEndSymbol(std::list<sax::Token>& input) const;

	template<typename T> friend class alib::api;
public:
	bool first(std::list<sax::Token>& input) const;
};

} /* namespace alphabet */

#endif /* SYMBOL_FROM_XML_PARSER_H_ */
