/*
 * FiniteAutomatonFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef FINITE_AUTOMATON_FROM_STRING_LEXER_H_
#define FINITE_AUTOMATON_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>
#include "../../std/istream.h"

namespace automaton {

class FiniteAutomatonFromStringLexer {
public:
	enum class TokenType {
		EPSILON_NFA,
		MULTI_INITIAL_STATE_NFA,
		NFA,
		DFA,
		OUT,
		IN,
		EPSILON,
		SEPARATOR,
		NONE,
		NEW_LINE,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
	};
private:
	std::istream& m_In;
	Token m_Current;
public:

	FiniteAutomatonFromStringLexer(std::istream&);
	FiniteAutomatonFromStringLexer& next();
	Token token();
};

} /* namepsace automaton */

#endif /* FINITE_AUTOMATON_FROM_STRING_LEXER_H_ */
