/*
 * SingleInitialState.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "SingleInitialState.h"

#include "../AutomatonException.h"

namespace automaton {

SingleInitialState::SingleInitialState(const State& initialState) : initialState(initialState) {
	addState(initialState);
}

void SingleInitialState::setInitialState(const State& state) {
	if (states.find(state) == states.end()) {
		throw AutomatonException("State " + (std::string) state.getName() + " cannot be set as initial state. It is not present in the automaton.");
	}

	initialState = state;
}

const State& SingleInitialState::getInitialState() const {
	return initialState;
}

} /* namespace automaton */

