/*
 * Map.cpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#include "ObjectsMap.h"
#include "../std/map.hpp"

#include <cstdlib>
#include <iostream>
#include <sstream>

namespace container {

ContainerBase* ObjectsMap::clone() const {
	return new ObjectsMap(*this);
}

ContainerBase* ObjectsMap::plunder() && {
	return new ObjectsMap(std::move(*this));
}

bool ObjectsMap::operator==(const ObjectBase& other) const {
	return other == *this;
}

bool ObjectsMap::operator<(const ObjectBase& other) const {
	return other > *this;
}

bool ObjectsMap::operator>(const ObjectBase& other) const {
	return other < *this;
}

bool ObjectsMap::operator==(const ObjectsMap& other) const {
	return static_cast<const std::map<alib::Object, alib::Object>>(*this) == static_cast<const std::map<alib::Object, alib::Object>>(other);
}

bool ObjectsMap::operator<(const ObjectsMap& other) const {
	return static_cast<const std::map<alib::Object, alib::Object>>(*this) < static_cast<const std::map<alib::Object, alib::Object>>(other);
}

void ObjectsMap::operator>>(std::ostream& os) const {
	os << *this;
}

ObjectsMap::operator std::string() const {
	std::stringstream ss;
	ss << *this;
	return std::move(ss).str();
}

} /* namespace container */
