/*
 * Set.cpp
 *
 * Created on: Apr 1, 2013
 * Author: Jan Travnicek
 */

#include "ObjectsVector.h"
#include "../std/vector.hpp"

#include <cstdlib>
#include <iostream>
#include <sstream>

namespace container {

ContainerBase* ObjectsVector::clone() const {
	return new ObjectsVector(*this);
}

ContainerBase* ObjectsVector::plunder() && {
	return new ObjectsVector(std::move(*this));
}

bool ObjectsVector::operator==(const ObjectBase& other) const {
	return other == *this;
}

bool ObjectsVector::operator<(const ObjectBase& other) const {
	return other > *this;
}

bool ObjectsVector::operator>(const ObjectBase& other) const {
	return other < *this;
}

bool ObjectsVector::operator==(const ObjectsVector& other) const {
	return static_cast<const std::vector<alib::Object>>(*this) == static_cast<const std::vector<alib::Object>>(other);
}

bool ObjectsVector::operator<(const ObjectsVector& other) const {
	return static_cast<const std::vector<alib::Object>>(*this) < static_cast<const std::vector<alib::Object>>(other);
}

void ObjectsVector::operator>>(std::ostream& os) const {
	os << *this;
}

ObjectsVector::operator std::string() const {
	std::stringstream ss;
	ss << *this;
	return std::move(ss).str();
}

} /* namespace container */
