/*
 * HexavigesimalLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "HexavigesimalLabel.h"
#include "../std/hexavigesimal.h"

namespace label {

HexavigesimalLabel::HexavigesimalLabel(int hexavigesimal) : hexavigesimal(hexavigesimal) {

}

LabelBase* HexavigesimalLabel::clone() const {
	return new HexavigesimalLabel(*this);
}

LabelBase* HexavigesimalLabel::plunder() && {
	return new HexavigesimalLabel(std::move(*this));
}

int HexavigesimalLabel::getData() const {
	return hexavigesimal;
}

bool HexavigesimalLabel::operator<(const alib::ObjectBase& other) const {
	return other > *this;
}

bool HexavigesimalLabel::operator==(const alib::ObjectBase& other) const {
	return other == *this;
}

bool HexavigesimalLabel::operator >(const alib::ObjectBase& other) const {
	return other < *this;
}


bool HexavigesimalLabel::operator <(const HexavigesimalLabel& other) const {
	return hexavigesimal < other.hexavigesimal;
}

bool HexavigesimalLabel::operator ==(const HexavigesimalLabel& other) const {
	return hexavigesimal == other.hexavigesimal;
}

void HexavigesimalLabel::operator>>(std::ostream& out) const {
	out << "(HexavigesimalLabel " << std::toBase26(hexavigesimal) << ")";
}

HexavigesimalLabel::operator std::string() const {
	return std::toBase26(hexavigesimal);
}

} /* namespace label */

