/*
 * ObjectLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author:Jan Travnicek 
 */

#include "ObjectLabel.h"

namespace label {

ObjectLabel::ObjectLabel(const alib::Object& label) : label(label) {

}

ObjectLabel::ObjectLabel(alib::Object&& label) : label(std::move(label)) {

}

LabelBase* ObjectLabel::clone() const {
	return new ObjectLabel(*this);
}

LabelBase* ObjectLabel::plunder() && {
	return new ObjectLabel(std::move(*this));
}

const alib::Object& ObjectLabel::getData() const {
	return label;
}

bool ObjectLabel::operator <(const alib::ObjectBase& other) const {
	return other > *this;
}

bool ObjectLabel::operator ==(const alib::ObjectBase& other) const {
	return other == *this;
}

bool ObjectLabel::operator >(const alib::ObjectBase& other) const {
	return other < *this;
}

bool ObjectLabel::operator <(const ObjectLabel& other) const {
	return label < other.label;
}

bool ObjectLabel::operator ==(const ObjectLabel& other) const {
	return label == other.label;
}

void ObjectLabel::operator>>(std::ostream& out) const {
	out << "(ObjectLabel " << label << ")";
}

ObjectLabel::operator std::string() const {
	return (std::string) label;
}

} /* namespace label */

