/*
 * PrimitiveLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "PrimitiveLabel.h"

namespace label {

PrimitiveLabel::PrimitiveLabel(const primitive::Primitive& primitive) : primitive(primitive) {

}

PrimitiveLabel::PrimitiveLabel(primitive::Primitive&& primitive) : primitive(std::move(primitive)) {

}

LabelBase* PrimitiveLabel::clone() const {
	return new PrimitiveLabel(*this);
}

LabelBase* PrimitiveLabel::plunder() && {
	return new PrimitiveLabel(std::move(*this));
}

const primitive::Primitive& PrimitiveLabel::getData() const {
	return primitive;
}

bool PrimitiveLabel::operator<(const alib::ObjectBase& other) const {
	return other > *this;
}

bool PrimitiveLabel::operator==(const alib::ObjectBase& other) const {
	return other == *this;
}

bool PrimitiveLabel::operator >(const alib::ObjectBase& other) const {
	return other < *this;
}


bool PrimitiveLabel::operator <(const PrimitiveLabel& other) const {
	return primitive < other.primitive;
}

bool PrimitiveLabel::operator ==(const PrimitiveLabel& other) const {
	return primitive == other.primitive;
}

void PrimitiveLabel::operator>>(std::ostream& out) const {
	out << "(PrimitiveLabel " << primitive << ")";
}

PrimitiveLabel::operator std::string() const {
	return (std::string) primitive;
}

} /* namespace label */

