/*
 * Void.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef VOID_H_
#define VOID_H_

#include "ObjectBase.h"
#include "../std/visitor.hpp"
#include "../common/wrapper.hpp"

namespace alib {

/**
 * Represents void.
 */
class Void : public std::acceptor<Void, VisitableObjectBase, ObjectBase> {
public:
	/**
	 * Creates a blank symbol.
	 * @param symbol name of the symbol
	 */
	explicit Void();

	virtual ObjectBase* clone() const;
	virtual ObjectBase* plunder() &&;

	virtual bool operator <(const alib::ObjectBase& other) const;
	virtual bool operator ==(const alib::ObjectBase& other) const;
	virtual bool operator >(const alib::ObjectBase& other) const;

	virtual bool operator ==(const Void& other) const;
	virtual bool operator <(const Void& other) const;

	virtual void operator>>(std::ostream& out) const;

	virtual operator std::string () const;

	virtual int selfTypeId() const {
		return typeId<Void>();
	}

	static Void VOID;
};

} /* namespace alib */

#endif /* VOID_H_ */
