/*
 * NextPrimitive.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef NEXT_PRIMITIVE_H_
#define NEXT_PRIMITIVE_H_

#include <list>
#include "Primitive.h"
#include "../sax/Token.h"

namespace primitive {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class NextPrimitive : public VisitablePrimitiveBase::visitor_type {
	void Visit(void*, const String& primitive);
	void Visit(void*, const Integer& primitive);
	void Visit(void*, const Character& primitive);

public:
	/**
	 * Prints XML representation of String to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	Primitive nextPrimitive(const Primitive& primitive);
};

} /* namespace primitive */

#endif /* NEXT_PRIMITIVE_H_ */
