/*
 * PrimitiveFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_FROM_STRING_LEXER_H_
#define PRIMITIVE_FROM_STRING_LEXER_H_

#include <string>
#include <sstream>

namespace primitive {

class PrimitiveFromStringLexer {
public:
	enum class TokenType {
		STRING,
		CHAR,
		INTEGER,
		TEOF,
		ERROR
	};

	struct Token {
	      TokenType type;
	      std::string value;
	};
private:
	std::istream& m_In;
	Token m_Current;
public:

	PrimitiveFromStringLexer(std::istream&);
	PrimitiveFromStringLexer& next();
	Token token();
};

} /* namespace primitive */

#endif /* PRIMITIVE_FROM_STRING_LEXER_H_ */
