/*
 * PrimitiveToXMLComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrimitiveToXMLComposer.h"
#include "Integer.h"
#include "String.h"
#include "Character.h"
#include "../std/itos.h"

#include "../Api.hpp"

namespace primitive {

std::list<sax::Token> PrimitiveToXMLComposer::compose(const Primitive& primitive) const {
	std::list<sax::Token> out;
	primitive.getData().Accept((void*) &out, alib::ToXMLComposers::toXMLComposers);
	return out;
}

std::list<sax::Token> PrimitiveToXMLComposer::compose(const PrimitiveBase& primitive) const {
	std::list<sax::Token> out;
	primitive.Accept((void*) &out, alib::ToXMLComposers::toXMLComposers);
	return out;
}

std::list<sax::Token> PrimitiveToXMLComposer::compose(const Integer& primitive) const {
	std::list<sax::Token> out;
	out.push_back(sax::Token("Integer", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(std::itos(primitive.getData()), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("Integer", sax::Token::TokenType::END_ELEMENT));
	return out;
}

std::list<sax::Token> PrimitiveToXMLComposer::compose(const Character& primitive) const {
	std::list<sax::Token> out;
	out.push_back(sax::Token("Character", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(std::string(1, primitive.getData()), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("Character", sax::Token::TokenType::END_ELEMENT));
	return out;
}

std::list<sax::Token> PrimitiveToXMLComposer::compose(const String& primitive) const {
	std::list<sax::Token> out;
	out.push_back(sax::Token("String", sax::Token::TokenType::START_ELEMENT));
	out.push_back(sax::Token(primitive.getData(), sax::Token::TokenType::CHARACTER));
	out.push_back(sax::Token("String", sax::Token::TokenType::END_ELEMENT));
	return out;
}

} /* namespace primitive */
