/*
 * String.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "String.h"

namespace primitive {

String::String(const std::string& data) : data(data) {

}

String::String(std::string&& data) : data(std::move(data)) {

}

PrimitiveBase* String::clone() const {
	return new String(*this);
}

PrimitiveBase* String::plunder() && {
	return new String(std::move(*this));
}

const std::string& String::getData() const {
	return data;
}

bool String::operator<(const alib::ObjectBase& other) const {
	return other > *this;
}

bool String::operator==(const alib::ObjectBase& other) const {
	return other == *this;
}

bool String::operator >(const alib::ObjectBase& other) const {
	return other < *this;
}


bool String::operator <(const String& other) const {
	return data < other.data;
}

bool String::operator ==(const String& other) const {
	return data == other.data;
}

void String::operator>>(std::ostream& out) const {
	out << "(String " << data << ")";
}

String::operator std::string() const {
	return data;
}

} /* namespace primitive */

