/*
 * RegExp.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef REG_EXP_H_
#define REG_EXP_H_

#include "../std/visitor.hpp"
#include "../common/wrapper.hpp"
#include "RegExpBase.h"
#include "../alphabet/Symbol.h"
#include "../string/LinearString.h"
#include <string>

namespace regexp {

/**
 * Wrapper around automata.
 */
typedef alib::wrapper<RegExpBase> RegExp;

regexp::RegExp regexpFrom( const std::string& string );

regexp::RegExp regexpFrom( const string::LinearString& string );

regexp::RegExp regexpFrom( const alphabet::Symbol& symbol );

regexp::RegExp regexpFrom( );

} /* namespace regexp */

#endif /* REG_EXP_H_ */

