/*
 * RegExpFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_FROM_STRING_PARSER_H_
#define REG_EXP_FROM_STRING_PARSER_H_

#include "RegExp.h"
#include "unbounded/UnboundedRegExpElements.h"
#include "formal/FormalRegExpElements.h"

#include "RegExpFromStringLexer.h"
#include "../alphabet/SymbolFromStringParser.h"
#include "RegExpFeatures.h"
#include "../FromStringParser.hpp"

namespace regexp {

class RegExpFromStringParser : public alib::FromStringParser<RegExp, FEATURES> {
	UnboundedRegExpElement* alternation();
	UnboundedRegExpElement* alternationCont(UnboundedRegExpElement* left);
	UnboundedRegExpElement* alternationContCont(UnboundedRegExpAlternation* left);
	
	UnboundedRegExpElement* concatenation();
	UnboundedRegExpElement* concatenationCont(UnboundedRegExpElement* left);
	UnboundedRegExpElement* concatenationContCont(UnboundedRegExpConcatenation* left);
	
	UnboundedRegExpElement* factor();
	UnboundedRegExpElement* star(UnboundedRegExpElement* elem);

	RegExpFromStringLexer m_RegexpLexer;
	alphabet::SymbolFromStringParser m_SymbolParser;

	virtual RegExp parse();
	virtual RegExp parse(const std::set<FEATURES>& features);
	bool next();
	virtual bool last();
public:
	virtual bool first();
	RegExpFromStringParser(std::istream&);

};

} /* namespace regexp */

#endif /* REG_EXP_FROM_STRING_PARSER_H_ */
