#ifndef __POINTER_HPP_
#define __POINTER_HPP_

#include <cstdlib>

namespace std {

template<typename T>
class pointer {
	T* ptr;
public:
	pointer(T* ptr) : ptr(ptr) {}

	bool operator<(const pointer<T>& other) const {
		if(ptr == other.ptr) return 0;
		if(ptr == NULL) return 1;
		if(other.ptr == NULL) return 0;
		return *ptr < *other.ptr;
	}

	bool operator==(const pointer<T>& other) const {
		if(ptr == other.ptr) return 1;
		if(ptr == NULL) return 0;
		if(other.ptr == NULL) return 0;
		return *ptr == *other.ptr;
	}

	friend ostream& operator<<(ostream& out, const pointer<T>& other) {
		if(other.ptr == NULL)
			out << "NULL";
		else
			out << *other.ptr;
		return out;
	}
};

} /* namespace std */

#endif /* __POINTER_HPP_ */

