/*
 * StringBase.h
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_BASE_H_
#define STRING_BASE_H_

#include "../std/visitor.hpp"
#include "../object/ObjectBase.h"

namespace string {

class StringBase;

typedef std::acceptor_base<StringBase,
			string::Epsilon, string::LinearString, string::CyclicString
	> VisitableStringBase;

/**
 * Represents string in an alphabet.
 */
class StringBase : public VisitableStringBase, public alib::ObjectBase {
public:
	using VisitableStringBase::Accept;
	using alib::VisitableObjectBase::Accept;

	virtual StringBase* clone() const = 0;
	virtual StringBase* plunder() && = 0;
};

} /* namespace string */

#endif /* STRING_BASE_H_ */

