//============================================================================
// Name        : aminimize.cpp
// Author      : Jan Travnicek
//============================================================================

#include <iostream>

#include <exception/AlibException.h>
#include <factory/DataFactory.hpp>

#include "minimize/dfa/MinimizeDFA.h"

int main(int argc, char** argv) {

	try {
		if (argc == 2 && std::string("-h").compare(argv[1]) == 0) {
			std::cout << "Automaton minimize." << std::endl << "Usage: aminimize automaton.xml" << std::endl;
			return -1;
		} else if (argc == 1 || (argc == 2 && std::string("--").compare(argv[1]) == 0)) {
			alib::DataFactory::toStdout(minimize::MinimizeDFA::minimize(alib::DataFactory::fromStdin<automaton::Automaton>()));
		} else if (argc == 2) {
			alib::DataFactory::toStdout(minimize::MinimizeDFA::minimize(alib::DataFactory::fromStdin<automaton::Automaton>()));
		} else {
			std::cout << "Automaton minimize require deterministic finite automaton" << std::endl;
			return 1;
		}

		return 0;

	} catch (const exception::AlibException& exception) {
		alib::DataFactory::toStdout(exception);
		return 1;
	} catch(...) {
		return 127;
	}
}
